Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions
Lucene::ValueSource Class Referenceabstract

Source of values for basic function queries. More...

`#include <ValueSource.h>`

Inheritance diagram for Lucene::ValueSource:

## Public Member Functions

virtual | ~ValueSource ()
virtual String | getClassName ()
boost::shared_ptr< ValueSource > | shared_from_this ()
virtual DocValuesPtr | getValues (const IndexReaderPtr &reader)=0
| Return the DocValues used by the function query.
virtual String | description ()=0
| Description of field, used in explain()
virtual String | toString ()
| Returns a string representation of the object.
virtual bool | equals (const LuceneObjectPtr &other)=0
| Needed for possible caching of query results - used by `ValueSourceQuery#equals(LuceneObjectPtr)`.
virtual int32_t | hashCode ()=0
| Needed for possible caching of query results - used by `ValueSourceQuery#hashCode()`.
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Source of values for basic function queries.

At its default/simplest form, values - one per doc - are used as the score of that doc.

Values are instantiated as `DocValues` for a particular reader. ValueSource implementations differ in RAM requirements: it would always be a factor of the number of documents, but for each document the number of bytes can be 1, 2, 4, or 8.

## Constructor & Destructor Documentation

## ◆ ~ValueSource()

virtual Lucene::ValueSource::~ValueSource | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::ValueSource::_getClassName | ( |  | ) |

inline static

## ◆ description()

virtual String Lucene::ValueSource::description | ( |  | ) |

pure virtual

Description of field, used in explain()

Implemented in Lucene::ByteFieldSource, Lucene::DoubleFieldSource, Lucene::FieldCacheSource, Lucene::IntFieldSource, Lucene::OrdFieldSource, and Lucene::ReverseOrdFieldSource.

## ◆ equals()

virtual bool Lucene::ValueSource::equals | ( | const LuceneObjectPtr & | other | ) |

pure virtual

Needed for possible caching of query results - used by `ValueSourceQuery#equals(LuceneObjectPtr)`.

Reimplemented from Lucene::LuceneObject.

Implemented in Lucene::FieldCacheSource, Lucene::OrdFieldSource, and Lucene::ReverseOrdFieldSource.

## ◆ getClassName()

virtual String Lucene::ValueSource::getClassName | ( |  | ) |

inline virtual

Reimplemented in Lucene::ByteFieldSource, Lucene::DoubleFieldSource, Lucene::FieldCacheSource, Lucene::IntFieldSource, Lucene::OrdFieldSource, and Lucene::ReverseOrdFieldSource.

## ◆ getValues()

virtual DocValuesPtr Lucene::ValueSource::getValues | ( | const IndexReaderPtr & | reader | ) |

pure virtual

Return the DocValues used by the function query.

Parameters

  reader | The IndexReader used to read these values. If any caching is involved, that caching would also be IndexReader based.

Implemented in Lucene::FieldCacheSource, Lucene::OrdFieldSource, and Lucene::ReverseOrdFieldSource.

## ◆ hashCode()

virtual int32_t Lucene::ValueSource::hashCode | ( |  | ) |

pure virtual

Needed for possible caching of query results - used by `ValueSourceQuery#hashCode()`.

Reimplemented from Lucene::LuceneObject.

Implemented in Lucene::FieldCacheSource, Lucene::OrdFieldSource, and Lucene::ReverseOrdFieldSource.

## ◆ shared_from_this()

boost::shared_ptr< ValueSource > Lucene::ValueSource::shared_from_this | ( |  | ) |

inline

## ◆ toString()

virtual String Lucene::ValueSource::toString | ( |  | ) |

virtual

Returns a string representation of the object.

Reimplemented from Lucene::LuceneObject.

The documentation for this class was generated from the following file:

- ValueSource.h

clucene.sourceforge.net